## ros-melodic-ml-classifiers 1.0.1

=== CMakeLists.txt ===
project(ml_classifiers)

set(ROS_VERSION $ENV{ROS_VERSION})

# Version-independent instructions
find_package(Eigen3 REQUIRED)
set(Eigen3_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIRS})
add_definitions(${EIGEN3_DEFINITIONS})

if(${ROS_VERSION} EQUAL 1)

  cmake_minimum_required(VERSION 2.8.3)

  # Default to C++11
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)
  endif()

  find_package(catkin REQUIRED
    COMPONENTS
    message_generation
    std_msgs
    roscpp
    pluginlib
  )

  include_directories(
    include
    src
    ${EIGEN3_INCLUDE_DIRS}
    ${catkin_INCLUDE_DIRS}
  )

  add_message_files(FILES
    ClassDataPoint.msg
    DIRECTORY msg
  )

  add_service_files(FILES
    AddClassData.srv
    ClassifyData.srv
    ClearClassifier.srv
    CreateClassifier.srv
    LoadClassifier.srv
    SaveClassifier.srv
    TrainClassifier.srv
    DIRECTORY srv
  )

  generate_messages(DEPENDENCIES std_msgs)

  catkin_package(
    DEPENDS Eigen3
    CATKIN_DEPENDS message_runtime std_msgs roscpp pluginlib
    INCLUDE_DIRS include
    LIBRARIES ZeroClassifier NearestNeighborClassifier SVMClassifier
  )

elseif(${ROS_VERSION} EQUAL 2)

  cmake_minimum_required(VERSION 3.5)

  # Default to C++14
  if(NOT CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
  endif()

  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wall -Wextra -Wpedantic)
  endif()

  add_definitions(-DPLUGINLIB__DISABLE_BOOST_FUNCTIONS)

  find_package(ament_cmake REQUIRED)
  find_package(rclcpp REQUIRED)
  find_package(rosidl_default_generators REQUIRED)
  find_package(pluginlib REQUIRED)
  find_package(std_msgs REQUIRED)

  include_directories(
    include
    src
    ${EIGEN3_INCLUDE_DIRS}
  )

  rosidl_generate_interfaces(${PROJECT_NAME}
    "msg/ClassDataPoint.msg"
    "srv/AddClassData.srv"
    "srv/ClassifyData.srv"
    "srv/ClearClassifier.srv"
    "srv/CreateClassifier.srv"
    "srv/LoadClassifier.srv"
    "srv/SaveClassifier.srv"
    "srv/TrainClassifier.srv"
    DEPENDENCIES std_msgs
  )

endif()

add_library(NearestNeighborClassifier SHARED
  src/nearest_neighbor_classifier.cpp)
add_library(SVMClassifier SHARED
  src/svm_classifier.cpp
  src/libsvm-3.14/svm.cpp)
add_library(ZeroClassifier SHARED
  src/zero_classifier.cpp)

if(${ROS_VERSION} EQUAL 1)

  add_executable(classifier_server
    nodes/ros1_classifier_server.cpp)

  target_link_libraries(classifier_server ${catkin_LIBRARIES})
  add_dependencies(classifier_server ${PROJECT_NAME}_generate_messages_cpp)

  install(TARGETS classifier_server ZeroClassifier NearestNeighborClassifier SVMClassifier
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

elseif(${ROS_VERSION} EQUAL 2)

  add_executable(classifier_server
    nodes/ros2_classifier_server.cpp)

  ament_target_dependencies(NearestNeighborClassifier
    "pluginlib")

  ament_target_dependencies(SVMClassifier
    "pluginlib")

  ament_target_dependencies(ZeroClassifier
    "pluginlib")

  ament_target_dependencies(classifier_server
    "rclcpp"
    "pluginlib")

  target_link_libraries(classifier_server
    ${rclcpp_LIBRARIES}
    ${pluginlib_LIBRARIES})

  target_include_directories(classifier_server PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

  rosidl_target_interfaces(classifier_server
    ${PROJECT_NAME}
    "rosidl_typesupport_cpp")

  install(
    DIRECTORY include/
    DESTINATION include
  )

  install(
    TARGETS classifier_server
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin
    INCLUDES DESTINATION include
  )

  install(
    TARGETS SVMClassifier
    EXPORT SVMClassifier
    LIBRARY DESTINATION lib
    INCLUDES DESTINATION include
  )

  install(
    TARGETS NearestNeighborClassifier
    EXPORT NearestNeighborClassifier
    LIBRARY DESTINATION lib
    INCLUDES DESTINATION include
  )

  install(
    TARGETS ZeroClassifier
    EXPORT ZeroClassifier
    LIBRARY DESTINATION lib
    INCLUDES DESTINATION include
  )

  ament_export_dependencies(rosidl_default_runtime)
  ament_export_dependencies(pluginlib)

  ament_export_include_directories(include)

  ament_export_interfaces(SVMClassifier HAS_LIBRARY_TARGET)
  ament_export_interfaces(NearestNeighborClassifier HAS_LIBRARY_TARGET)
  ament_export_interfaces(ZeroClassifier HAS_LIBRARY_TARGET)

  pluginlib_export_plugin_description_file(ml_classifiers
    ros2_default_classifiers_plugin.xml)

  if(BUILD_TESTING)
    find_package(ament_lint_auto REQUIRED)

    ament_lint_auto_find_test_dependencies()
  endif()

  ament_package()

endif()

=== debian/changelog ===
ros-melodic-ml-classifiers (1.0.1-1stretch) stretch; urgency=high

  * Merge pull request #3 <https://github.com/astuff/ml_classifiers/issues/3> from dirk-thomas/patch-1
  * add build dep on ros_environment to ensure the env variable ROS_VERSION is defined
  * Contributors: Dirk Thomas, Joshua Whitley

 -- AutonomouStuff Software Development Team <software@autonomoustuff.com>  Mon, 15 Apr 2019 05:00:00 -0000

ros-melodic-ml-classifiers (1.0.0-1stretch) stretch; urgency=high

  * Merge pull request #2 <https://github.com/astuff/ml_classifiers/issues/2> from astuff/ros-transition
    ROS2 Hybrid Package - now builds in ROS Kinetic/Melodic and ROS2 Crystal
  * ROS2: Making classifier_server a class.
  * Creating separate ros1/ros2 xml files.
  * ROS1: Removing roslint in favor of ROS2 linting.
  * ROS2: Disabling boost in pluginlib.
  * ROS2: Updating copyrights to conform to ament_copyright.
  * ROS2: Fixing cmake exports.
  * Contributors: Joshua Whitley

 -- AutonomouStuff Software Development Team <software@autonomoustuff.com>  Tue, 09 Apr 2019 05:00:00 -0000

ros-melodic-ml-classifiers (0.4.1-1stretch) stretch; urgency=high

  * Replacing typedefs with aliases.
  * Add run_tests hook for roslint.
  * Adding C++11 specifier.
  * Contributors: Joshua Whitley

 -- AutonomouStuff Software Development Team <software@autonomoustuff.com>  Thu, 21 Mar 2019 05:00:00 -0000

ros-melodic-ml-classifiers (0.4.0-1stretch) stretch; urgency=high

  * Updating URLs in package.xml.
  * Updating README and package.xml with new data.
  * Merge pull request #1 <https://github.com/astuff/ml_classifiers/issues/1> from sniekum/master
    Merging from upstream before taking ownership.
  * CI: Adding CircleCI tests.
  * Replacing createClassInstance with createInstance in pluginlib.
  * Merge pull request #7 <https://github.com/astuff/ml_classifiers/issues/7> from astuff/melodic-devel
    Melodic fixes.
  * Fixed compilation problems in Melodic.
  * Fixing CMakeLists.txt and updating package.xml to version 2.
  * Merge pull request #6 <https://github.com/astuff/ml_classifiers/issues/6> from wkentaro/migration-to-jade
    [ml_classifers] eigen -> Eigen3 in CMakeLists.txt
    See: http://wiki.ros.org/jade/Migration#Eigen_CMake_Module_in_cmake_modules
  * Merge pull request #3 <https://github.com/astuff/ml_classifiers/issues/3> from jolting/indigo-devel
    Fix build for Indigo
  * Contributors: Joshua Whitley, Kentaro Wada, Scott Niekum

 -- AutonomouStuff Software Development Team <software@autonomoustuff.com>  Tue, 26 Feb 2019 06:00:00 -0000

ros-melodic-ml-classifiers (0.3.1-1stretch) stretch; urgency=high

  * Fix build for indigo
  * Merge pull request #2 <https://github.com/sniekum/ml_classifiers/issues/2> from davetcoleman/rospack_dep
    Missing dep on rosdep
  * Missing dep on rosdep
  * updated version number
  * Merge pull request #1 <https://github.com/sniekum/ml_classifiers/issues/1> from k-okada/hydro
    upgrade to hydro
  * upgrade to hydro
  * added rosdep eigen
  * removed eigen rosdep
  * updated version
  * fixed rosdep
  * Switched linear kernel to RBF
  * Moved to github
  * Contributors: Dave Coleman, Hunter Laux, Kei Okada, Scott Niekum, sniekum

 -- AutonomouStuff Software Development Team <software@autonomoustuff.com>  Mon, 15 Sep 2014 05:00:00 -0000

=== debian/control ===
Source: ros-melodic-ml-classifiers
Section: misc
Priority: extra
Maintainer: AutonomouStuff Software Development Team <software@autonomoustuff.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-melodic-catkin, ros-melodic-message-generation, ros-melodic-pluginlib, ros-melodic-ros-environment, ros-melodic-roscpp, ros-melodic-roslib, ros-melodic-std-msgs
Homepage: http://wiki.ros.org/ml_classifiers
Standards-Version: 3.9.2

Package: ros-melodic-ml-classifiers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-melodic-message-runtime, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-roslib, ros-melodic-std-msgs
Description: ml_classifiers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-ml-classifiers//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
